#!@PERL@
#
# proc-httpd-access.pl,v 1.5 2003/03/15 17:29:50 kim Exp
#
# Output TOP 10 requested web documents
#
# 1996-07-28  Kimmo Suominen
#
# First tell the daemon to switch to a new file
#
#if (-r '/var/run/httpd.pid') {
#    open(DPIDF, '</var/run/httpd.pid');
#    $dpid = <DPIDF>;
#    kill 'HUP', $dpid;
#    close(DPIDF);
#}
#
# Process the log
#
# The common log format is: "%h %l %u %t \"%r\" %s %b"
#
# We use an extended format to log virtual site, user agent and referer
# "[%v] %h %l %u %t \"%r\" %s %b \"%{User-Agent}i\" \"%{Referer}i\""
#
# This script should be processing both just fine.
#
while (<>) {
    if (m!^(\[([^\s]+)\]\s+)?.*\s+"?GET\s+(.*?)(\s+HTTP/[.0-9]+)?"?\s+([-0-9]+)\s+(([0-9]+)((\s+"([^"]+)")(\s+"([^"]+))?)?)?!) {
	$sitenm = $2;
	$rawurl = $3;
	$stcode = $5;
	next if ($stcode != 200);
	$sitenm = "" if (! $sitenm);
	$site{$sitenm}++;
	$bytes{$sitenm} += $7 if defined($7);
	$rawbrowser = $10 if defined($10);
	$referer = $12 if defined($12);
	$url = "";
	while ($rawurl =~ m!(.*?)%([0-9a-fA-F]{2})(.*)!) {
	    $url .= $1 . chr(hex($2));
	    $rawurl = $3;
	}
	$url .= $rawurl;
	# strip GET parameters
	$url =~ s/\?.*//;
	# strip language codes from URL
	$url =~ s/\.(de|en|es|fi|fr|sv)(\.[^\/]+)?$/\2/;
	# strip default index file if explicitly addressed
	$url =~ s!/(default|index)\.(cgi|s?html?|php|pl)$!/!;
	# skip audio files, graphics, executables, style sheets, proxy confs
	next if ($url =~ m!\.(au|css|exe|gif|jpe?g|midi?|pac|png|x[bp]m)$!i);
	# skip FrontPage authoring URLs
	next if ($url =~ m!/_vti_!i);
	# count the rest
	$doc{$sitenm}{$url}++;
	# We only want major version number for each browser
	# MSIE tries hard to look like Mozilla -- try to detect
	if ($rawbrowser =~ m!\s*(([^/ 0-9]+)[/ ]?([0-9]+)?)(.*\W(MSIE\s+[0-9]+)\W)?!) {
	    if (defined($5)) {
		$browser{$5}++;
	    } else {
		$browser{$2 . ' ' . $3}++
	    }
	}
    }
}
#
# Output TOP 10 browsers
#
$k = 1;
printf "%10s %-s\n", "TOP 10", "browsers by successful accesses";
printf "%10s %-s\n", "--------", "------------------------------------------------------------";
foreach $i (sort {$browser{$b} <=> $browser{$a}} (keys %browser)) {
    printf "%10d %-s\n", $browser{$i}, $i;
    last if (++$k > 10);
}
printf "\n";
#
# Output TOP 10 documents
#
foreach $j (sort (keys %site)) {
    $k = 1;
    printf "%10d accesses on %-s (%.1f kB)\n", $site{$j},
	($j eq "" ? "default server" : $j), $bytes{$j} / 1024;
    printf "%10s %-s\n", "--------", "------------------------------------------------------------";
    foreach $i (sort {$doc{$j}{$b} <=> $doc{$j}{$a}} (keys %{$doc{$j}})) {
	printf "%10d %-s\n", $doc{$j}{$i}, $i;
	last if (++$k > 10);
    }
    printf "\n";
}
